package com.retail_store.order_management.application;

import com.retail_store.order_management.service.RetailStore;
import com.retail_store.order_management.service.RetailStoreService;

import java.sql.SQLException;
import java.util.Scanner;
import java.util.logging.Logger;

import static com.retail_store.order_management.utils.Utility.getInt;

public class OrderManagement {
    private Scanner scanner;
    private final Logger logger;

    public OrderManagement() {
        System.setProperty("java.util.logging.SimpleFormatter.format",
                "%5$s %n");
        this.scanner = new Scanner(System.in);
        this.logger = Logger.getLogger(OrderManagement.class.getName());
    }

    public void menu() {
        boolean flag = true;
        logger.info("Welcome to GAP Business Management");
        RetailStore gap = new RetailStoreService();
        String menu = "\n------------------------\nMenu\n------------------------\n" +
                "1. Add product to your stock\n------------------------\n" +
                "2. Order Product\n------------------------\n" +
                "3. Get order details\n------------------------\n" +
                "4. Exit";
        logger.info(menu);
        while (flag) {
            int menuOption;
            menuOption = getInt();
            switch (menuOption) {
                case 1:
                    try {
                        gap.addProducts();
                    } catch (Exception e) {
                        e.printStackTrace();
                        menu();
                    }
                    logger.info("\n------------------------\nPlease enter 5 for menu\n------------------------\n" +
                            "To exit please enter 4\n------------------------\n" +
                            "To Add more enter 1\n------------------------\n");
                    break;
                case 2:
                    gap.placeOrders();
                    logger.info("\n------------------------\nPlease enter 5 for menu\n------------------------\n" +
                            "To exit please enter 4");
                    break;
                case 3:
                    gap.showOrders();
                    logger.info("\n------------------------\nPlease enter 5 for menu\n------------------------\n" +
                            "To exit please enter 4");
                    break;
                case 4:

                    flag = false;
                    break;
                case 5:
                    logger.info(menu);
                    break;
                default:
                    logger.warning("\n------------------------\nPlease enter valid menu option\n------------------------\n");
                    logger.info(menu);
            }
        }
    }

    public static void main(String[] args) throws SQLException {
        OrderManagement orderManagement = new OrderManagement();
        orderManagement.menu();
    }
}
